Index: issm/trunk/src/m/plot/plot_BC.py
===================================================================
--- issm/trunk/src/m/plot/plot_BC.py	(revision 27035)
+++ issm/trunk/src/m/plot/plot_BC.py	(revision 27232)
@@ -4,4 +4,5 @@
 from plot_icefront import plot_icefront
 from hydrologydc import hydrologydc
+from hydrologyglads import hydrologyglads
 from mpl_toolkits.mplot3d import Axes3D
 from mpl_toolkits.axes_grid1.inset_locator import inset_axes
@@ -36,5 +37,6 @@
         #define what to plot with plot style
         spc_dict = {'spcvx': ['stressbalance', 'o', 'r', 240, 'vx Dirichlet'],
-                    'spcvy': ['stressbalance', 'o', 'b', 160, 'vy Dirichlet']}
+                    'spcvy': ['stressbalance', 'o', 'b', 160, 'vy Dirichlet'],
+                    'spcthickness': ['masstransport', 'o', 'k', 40, 'Thickness']}
         if not is2d:
             spc_dict['spcvz'] = ['stressbalance', 'o', 'y', 80, 'vy Dirichlet']
@@ -44,4 +46,7 @@
             if md.hydrology.isefficientlayer:
                 spc_dict['spcsediment_head'] = ['hydrology', '^', 'b', 240, 'IDS Head']
+
+        if isinstance(md.hydrology, hydrologyglads):
+            spc_dict['spcphi'] = ['hydrology', 'v', 'r', 240, 'phi']
 
         for key in spc_dict:
Index: issm/trunk/src/m/plot/plot_edgeoverlay.py
===================================================================
--- issm/trunk/src/m/plot/plot_edgeoverlay.py	(revision 27232)
+++ issm/trunk/src/m/plot/plot_edgeoverlay.py	(revision 27232)
@@ -0,0 +1,133 @@
+import numpy as np
+import matplotlib as mpl
+import matplotlib.pyplot as plt
+from processmesh import processmesh
+from matplotlib import collections
+from scipy.stats import percentileofscore
+
+
+def plot_edgeoverlay(md, datain, options, ax):
+    '''
+    plot_channels - plot channels area for GLADS
+    Usage:
+        plot_channels(md, options, fig, axes)
+
+    See also: PLOTMODEL'''
+
+    # if md.mesh.numberofedges not in np.shape(datain):
+    #     raise ValueError('Data must be defined on edges to be ploted as an edge overlay')
+
+    x, y, z, elements, is2d, isplanet = processmesh(md, [], options)
+    Edges = md.mesh.edges - 1
+
+    #First we mask values under a given value define by quantiles
+    if options.exist('edgemin'):
+        minval = options.getfieldvalue('edgemin', 0)
+        minquant = percentileofscore(datain, minval, kind='weak')
+        minquant = minquant / 100
+    else:
+        minquant = 0.7
+        minval = np.quantile(datain, minquant)
+    print("For the overlay we plot values above {:.4g} wich corresponds to the {}% percentile".format(minval, minquant * 100))
+
+    flags = datain > minval  #6.7e-5  # this is appropriate for channel Area (perhaps)
+
+    edgetype = options.getfieldvalue('edgetype', 'thickness')
+
+    if edgetype == "color":
+        #create an nodewise dataset from edges
+        NodeMask = np.ones(np.shape(md.mesh.x), dtype=bool)
+        #We grab all the starts from the unmasked edges
+        Starters = Edges[np.where(flags), 0]
+        NodeMask[Starters] = False
+        Xstart = np.ma.array(x, mask=NodeMask)
+        Ystart = np.ma.array(y, mask=NodeMask)
+
+        NodeMask = np.ones(np.shape(md.mesh.x), dtype=bool)
+        Enders = Edges[np.where(flags), 1]
+        NodeMask[Enders] = False
+        Xend = np.ma.array(x, mask=NodeMask)
+        Yend = np.ma.array(y, mask=NodeMask)
+
+        #define vectors from the start and end point of the unmasked edges
+        EdgeEnd = Edges[:, 1]
+        EdgeStart = Edges[:, 0]
+        quiverU = np.ma.array(Xend[EdgeEnd] - Xstart[EdgeStart], mask=np.invert(flags))
+        quiverV = np.ma.array(Yend[EdgeEnd] - Ystart[EdgeStart], mask=np.invert(flags))
+
+        #mask out the values from the data and create colorscale
+        Masked = np.ma.masked_array(datain, mask=np.invert(flags))
+        cbar_extend = 0
+        edgemap = plt.cm.get_cmap('inferno')
+        if options.exist('cedgeaxis'):
+            lims = options.getfieldvalue('cedgeaxis', [Masked.min(), Masked.max()])
+            edgenorm = mpl.colors.Normalize(vmin=lims[0], vmax=lims[1])
+            if lims[0] > Masked.min():
+                edgemap.set_under('r')
+                cbar_extend += 2
+            if lims[1] < Masked.max():
+                edgemap.set_over('k')
+                cbar_extend += 1
+        else:
+            edgenorm = mpl.colors.Normalize(vmin=Masked.min(), vmax=Masked.max())
+
+        if cbar_extend == 0:
+            extend = 'neither'
+        elif cbar_extend == 1:
+            extend = 'max'
+        elif cbar_extend == 2:
+            extend = 'min'
+        elif cbar_extend == 3:
+            extend = 'both'
+
+        ax.quiver(Xstart[EdgeStart], Ystart[EdgeStart], quiverU, quiverV, datain,
+                  units="xy", angles="xy", scale_units="xy", scale=1,
+                  headwidth=0, headlength=0, width=100, headaxislength=0,
+                  norm=edgenorm, cmap=edgemap)
+
+        #plt.colorbar(plt.cm.ScalarMappable(norm=edgenorm, cmap=edgemap), ax=ax, extend=extend, orientation='horizontal', anchor=(1, 0))
+        cbarax = ax.inset_axes([0.02, 0.02, 0.96, 0.05])
+        #inset_axes(ax, width="100%", height="5%", loc='lower center', borderpad=-5)
+        mpl.colorbar.ColorbarBase(cbarax, norm=edgenorm, cmap=edgemap, extend=extend, orientation='horizontal', ticklocation='top')
+
+    elif edgetype == 'thickness':
+        #First we classify a range
+        if options.exist('edgeranges'):
+            edgeranges = options.getfieldvalue('edgeranges', 2)
+        else:
+            edgeranges = 2
+
+        quantrange = np.linspace(minquant, 1, edgeranges + 1)[:-1]
+        flags = []
+        legtext = []
+        for Qindex, quantile in enumerate(quantrange):
+            if quantile < quantrange[-1]:
+                lowquant = np.quantile(datain, quantile)
+                highquant = np.quantile(datain, quantrange[Qindex + 1])
+                flags.append(np.logical_and(datain >= lowquant, datain <= highquant))
+                legtext.append('From  {:.2g} to {:.2g}'. format(lowquant, highquant))
+            else:
+                lowquant = np.quantile(datain, quantile)
+                flags.append((datain > lowquant))
+                legtext.append('More than {:.2g}'.format(lowquant))
+
+        flags = np.asarray(np.squeeze(flags))
+        EdgeEnd = Edges[:, 1]
+        EdgeStart = Edges[:, 0]
+
+        for index in range(edgeranges):
+            linecol = []
+            #We loop on the result and aonly add to a linecollection the flaged edges.
+            for datindex, datval in enumerate(datain):
+                if flags[index, datindex]:
+                    linecol.append([(x[EdgeStart[datindex]], y[EdgeStart[datindex]]),
+                                    (x[EdgeEnd[datindex]], y[EdgeEnd[datindex]])])
+
+            lc = collections.LineCollection(linecol, color='k', linewidth=0.5 + index,
+                                            label=legtext[index])
+            ax.add_collection(lc)
+
+        ax.legend(title='Overlay')
+
+    else:
+        print("Only 'color', and 'thickness' are accepted as edgeoverlay types")
Index: issm/trunk/src/m/plot/plot_icefront.py
===================================================================
--- issm/trunk/src/m/plot/plot_icefront.py	(revision 27035)
+++ issm/trunk/src/m/plot/plot_icefront.py	(revision 27232)
@@ -1,4 +1,5 @@
 import numpy as np
 from processmesh import processmesh
+import matplotlib as mpl
 from mpl_toolkits.mplot3d.art3d import Line3DCollection
 from mpl_toolkits.axes_grid1.inset_locator import inset_axes
@@ -26,4 +27,10 @@
     icefront = np.where(np.logical_and(iceelement != nodes_per_elt, iceelement != 0))
 
+    oceannodes = md.mask.ocean_levelset < 0
+    oceanelement = np.sum(oceannodes[elements], axis=1)
+
+    #icefront check
+    groundingline = np.where(np.logical_and(oceanelement != nodes_per_elt, oceanelement != 0))
+
     #plot mesh
     if is2d:
@@ -32,6 +39,11 @@
         #highlight elements on neumann
         if len(icefront[0]) > 0:
-            colors = np.asarray([0.5 for element in elements[icefront]])
-            ax.tripcolor(x, y, elements[icefront], facecolors=colors, alpha=0.5, label='elements on ice front')
+            colors = np.ones(np.shape(elements[icefront])[0])
+            cmap = mpl.colors.ListedColormap("navy")
+            ax.tripcolor(x, y, elements[icefront], facecolors=colors, edgecolor='k', label='elements on ice front', cmap=cmap)
+        if len(groundingline[0]) > 0:
+            colors = np.ones(np.shape(elements[groundingline])[0])
+            cmap = mpl.colors.ListedColormap("limegreen")
+            ax.tripcolor(x, y, elements[groundingline], facecolors=colors, edgecolor='k', label='elements on grounding line', cmap=cmap)
     else:
         ax = inset_axes(ax, width='100%', height='100%', loc=3, borderpad=0, axes_class=Axes3D)
Index: issm/trunk/src/m/plot/plot_manager.py
===================================================================
--- issm/trunk/src/m/plot/plot_manager.py	(revision 27035)
+++ issm/trunk/src/m/plot/plot_manager.py	(revision 27232)
@@ -27,5 +27,5 @@
     currently generated using matplotlib's AxesGrid toolkit.
 
-    'gridindex' is passed through to specialized plot* functions and 
+    'gridindex' is passed through to specialized plot* functions and
     applyoptions.
 
@@ -89,5 +89,4 @@
     # }}}
 
-    #process data and model
     x, y, z, elements, is2d, isplanet = processmesh(md, data, options)
     data2, datatype = processdata(md, data, options)
Index: issm/trunk/src/m/plot/plot_mesh.py
===================================================================
--- issm/trunk/src/m/plot/plot_mesh.py	(revision 27035)
+++ issm/trunk/src/m/plot/plot_mesh.py	(revision 27232)
@@ -21,6 +21,10 @@
     fig.delaxes(axgrid.cbar_axes[gridindex])
 
+    #retrieve some options
+    edgecolor=options.getfieldvalue('edgecolor','k')
+    linewidth=options.getfieldvalue('linewidth',1)
+
     if is2d:
-        ax.triplot(x, y, elements)
+        ax.triplot(x, y, elements,color=edgecolor,linewidth=linewidth)
     else:
         ax = inset_axes(axgrid[gridindex], width='100%', height='100%', loc=3, borderpad=0, axes_class=Axes3D)
Index: issm/trunk/src/m/plot/plot_transient_movie.m
===================================================================
--- issm/trunk/src/m/plot/plot_transient_movie.m	(revision 27035)
+++ issm/trunk/src/m/plot/plot_transient_movie.m	(revision 27232)
@@ -12,5 +12,5 @@
 	if exist(options,'transient_movie_field'),
 		field=getfieldvalue(options,'transient_movie_field');
-	elseif ischar(getfieldvalue(options,'data'))
+	elseif ischar(getfieldvalue(options,'data')) && ~strcmp(getfieldvalue(options,'data'),'transient_movie')
 		field=getfieldvalue(options,'data');
 	else
@@ -43,4 +43,6 @@
 	elseif exist(options,'steps'),
 		steps = getfieldvalue(options,'steps');
+	elseif exist(options,'step'),
+		steps = getfieldvalue(options,'step');
 	else
 		steps=1:length(results);
Index: issm/trunk/src/m/plot/plot_unit.py
===================================================================
--- issm/trunk/src/m/plot/plot_unit.py	(revision 27035)
+++ issm/trunk/src/m/plot/plot_unit.py	(revision 27232)
@@ -33,13 +33,9 @@
 
     # colormap
-    # {{{ give number of colorlevels and transparency
+    # give number of colorlevels and transparency {{{
     colorlevels = options.getfieldvalue('colorlevels', 128)
     alpha = options.getfieldvalue('alpha', 1)
-    if alpha < 1:
-        antialiased = True
-    else:
-        antialiased = False
-    # }}}
-    # {{{ define wich colormap to use
+    # }}}
+    # define wich colormap to use {{{
     try:
         defaultmap = plt.cm.get_cmap('viridis', colorlevels)
@@ -51,13 +47,7 @@
     else:
         cmap = getcolormap(options)
-    if options.exist('cmap_set_over'):
-        over = options.getfieldvalue('cmap_set_over', '0.5')
-        cmap.set_over(over)
-    if options.exist('cmap_set_under'):
-        under = options.getfieldvalue('cmap_set_under', '0.5')
-        cmap.set_under(under)
     options.addfield('colormap', cmap)
     # }}}
-    # {{{ if plotting only one of several layers reduce dataset, same for surface
+    # if plotting only one of several layers reduce dataset, same for surface {{{
     if options.getfieldvalue('layer', 0) >= 1:
         plotlayer = options.getfieldvalue('layer', 0)
@@ -68,5 +58,5 @@
         data = data[(plotlayer - 1) * slicesize:plotlayer * slicesize]
     # }}}
-    # {{{ Get the colormap limits
+    # Get the colormap limits {{{
     dataspread = np.nanmax(data) - np.nanmin(data)
     if dataspread != 0.:
@@ -75,8 +65,10 @@
         limextent = 0.
 
-    if options.exist('clim'):
-        lims = options.getfieldvalue('clim', [np.nanmin(data), np.nanmax(data)])
-    elif options.exist('caxis'):
+    if options.exist('caxis'):
         lims = options.getfieldvalue('caxis', [np.nanmin(data), np.nanmax(data)])
+        if lims[0] > np.nanmin(data):
+            options.addfielddefault('cmap_set_under', 'r')
+        if lims[1] < np.nanmax(data):
+            options.addfielddefault('cmap_set_over', 'k')
     else:
         if limextent == 0.:
@@ -87,20 +79,37 @@
         else:
             lims = [np.nanmin(data), np.nanmax(data)]
-    # }}}
-    # {{{ Set the spread of the colormap (default is normal
+
+    cbar_extend = 0
+    if options.exist('cmap_set_over'):
+        over = options.getfieldvalue('cmap_set_over', 'k')
+        cmap.set_over(over)
+        cbar_extend += 1
+    if options.exist('cmap_set_under'):
+        under = options.getfieldvalue('cmap_set_under', 'r')
+        cmap.set_under(under)
+        cbar_extend += 2
+    # }}}
+
+    # colorbar extension {{{
+    if cbar_extend == 0:
+        extend = 'neither'
+    elif cbar_extend == 1:
+        extend = 'max'
+    elif cbar_extend == 2:
+        extend = 'min'
+    elif cbar_extend == 3:
+        extend = 'both'
+    options.addfielddefault('cbar_extend', extend)
+    # }}}
+    # Set the spread of the colormap (default is normal) {{{
     if options.exist('log'):
         norm = mpl.colors.LogNorm(vmin=lims[0], vmax=lims[1])
     else:
         norm = mpl.colors.Normalize(vmin=lims[0], vmax=lims[1])
-    if options.exist('log'):
-        norm = mpl.colors.LogNorm(vmin=lims[0], vmax=lims[1])
-    else:
-        norm = mpl.colors.Normalize(vmin=lims[0], vmax=lims[1])
     options.addfield('colornorm', norm)
     # }}}
 
     # Plot depending on the datatype
-    # {{{ data are on elements
-
+    # data are on elements {{{
     if datatype == 1:
         if is2d:
@@ -109,4 +118,5 @@
             else:
                 triangles = mpl.tri.Triangulation(x, y, elements)
+
             tri = ax.tripcolor(triangles, data, colorlevels, cmap=cmap, norm=norm, alpha=alpha, edgecolors=edgecolor)
         else:
@@ -160,6 +170,5 @@
 
     # }}}
-    # {{{ data are on nodes
-
+    # data are on nodes {{{
     elif datatype == 2:
         if is2d:
@@ -169,15 +178,8 @@
             else:
                 triangles = mpl.tri.Triangulation(x, y, elements)
-    #tri = ax.tricontourf(triangles, data, colorlevels, cmap = cmap, norm=norm, alpha = alpha)
-            if options.exist('log'):
-                if alpha < 1:  #help with antialiasing
-                    tri = ax.tricontour(triangles, data, colorlevels, cmap=cmap, norm=norm, alpha=0.1, antialiased=antialiased)
-                tri = ax.tricontourf(triangles, data, colorlevels, cmap=cmap, norm=norm, alpha=alpha, antialiased=antialiased)
+            if edgecolor == 'None':
+                tri = ax.tripcolor(triangles, data, cmap=cmap, norm=norm, alpha=alpha, shading='gouraud')
             else:
-                if alpha < 1:  #help with antialiasing
-                    tri = ax.tricontour(triangles, data, colorlevels, cmap=cmap, norm=norm, alpha=0.1, antialiased=antialiased)
-                tri = ax.tricontourf(triangles, data, colorlevels, cmap=cmap, norm=norm, alpha=alpha, extend='both', antialiased=antialiased)
-            if edgecolor != 'None':
-                ax.triplot(x, y, elements, color=edgecolor)
+                tri = ax.tripcolor(triangles, data, cmap=cmap, norm=norm, alpha=alpha, edgecolors=edgecolor)
         else:
             #first deal with the colormap
@@ -185,5 +187,4 @@
             loccmap.set_array(lims)
             loccmap.set_clim(vmin=lims[0], vmax=lims[1])
-
     #deal with prism sides
             recface = np.vstack((elements[:, 0], elements[:, 1], elements[:, 4], elements[:, 3])).T
@@ -222,5 +223,5 @@
 
     # }}}
-    # {{{ plotting quiver
+    # plotting quiver {{{
     elif datatype == 3:
         if is2d:
@@ -230,14 +231,24 @@
         return
     # }}}
-    # {{{ plotting P1 Patch (TODO)
+    # plotting P1 Patch (TODO) {{{
     elif datatype == 4:
         print('plot_unit message: P1 patch plot not implemented yet')
         return
     # }}}
-    # {{{ plotting P0 Patch (TODO)
+    # plotting P0 Patch (TODO) {{{
     elif datatype == 5:
         print('plot_unit message: P0 patch plot not implemented yet')
         return
     # }}}
+    # plotting edges  {{{
+    elif datatype == 6:
+        if is2d:
+            triangles = mpl.tri.Triangulation(x, y, elements)
+            tri = ax.tripcolor(triangles, data, cmap=cmap, norm=norm, alpha=alpha, edgecolors=edgecolor)
+
+        else:
+            print("edge plotting is not implemented for 3D")
+        return
+    # }}}
     else:
         raise ValueError('datatype = %d not supported' % datatype)
Index: issm/trunk/src/m/plot/plotmodel.py
===================================================================
--- issm/trunk/src/m/plot/plotmodel.py	(revision 27035)
+++ issm/trunk/src/m/plot/plotmodel.py	(revision 27232)
@@ -28,33 +28,27 @@
     numberofplots = options.numberofplots
 
-    #get number of subplots
-    subplotwidth = ceil(sqrt(numberofplots))
+    #get the "optimal" number of subfigures in a row/col
+    if (np.nanmax(md.mesh.x) - np.nanmin(md.mesh.x)) > (np.nanmax(md.mesh.y) - np.nanmin(md.mesh.y)):
+        maxrow = ceil(sqrt(numberofplots))
+        maxcol = ceil(numberofplots / maxrow)
+    else:
+        maxcol = ceil(sqrt(numberofplots))
+        maxrow = ceil(numberofplots / maxcol)
 
-    # TODO: Check that commenting this out is correct; we do not need a hold
-    # under matplotlib, right?
-    #
-    # #get hold
-    # hold = options.list[0].getfieldvalue('hold', False)
-
-    #if nrows and ncols specified, then bypass
+    #If any  of nrows or ncols are given we use that
     if options.list[0].exist('nrows'):
         nrows = options.list[0].getfieldvalue('nrows')
-        nr = True
+        if options.list[0].exist('ncols'):
+            ncols = options.list[0].getfieldvalue('ncols')
+        else:
+            ncols = ceil(numberofplots / nrows)
+    elif options.list[0].exist('ncols'):
+        ncols = options.list[0].getfieldvalue('ncols')
+        nrows = ceil(numberofplots / ncols)
     else:
-        nrows = np.ceil(numberofplots / subplotwidth)
-        nr = False
-
-    if options.list[0].exist('ncols'):
-        ncols = options.list[0].getfieldvalue('ncols')
-        nc = True
-    else:
-        ncols = int(subplotwidth)
-        nc = False
+        nrows = maxrow
+        ncols = maxcol
     ncols = int(ncols)
     nrows = int(nrows)
-
-    #check that nrows and ncols were given at the same time!
-    if nr != nc:
-        raise Exception('plotmodel error message: nrows and ncols need to be specified together, or not at all')
 
     # Go through plots
@@ -86,9 +80,9 @@
         #       taken from https://matplotlib.org/api/_as_gen/mpl_toolkits.axes_grid1.axes_grid.ImageGrid.html
         #
-        direction = options.list[0].getfieldvalue('direction', 'row') # {"row", "column"}, default: "row"
-        axes_pad = options.list[0].getfieldvalue('axes_pad', 0.25) # float or (float, float), default : 0.02; Padding or (horizonal padding, vertical padding) between axes, in inches
-        add_all = options.list[0].getfieldvalue('add_all', True) # bool, default: True
-        share_all = options.list[0].getfieldvalue('share_all', True) # bool, default: False
-        label_mode = options.list[0].getfieldvalue('label_mode', 'L') # {"L", "1", "all"}, default: "L"; Determines which axes will get tick labels: "L": All axes on the left column get vertical tick labels; all axes on the bottom row get horizontal tick labels;. "1": Only the bottom left axes is labelled. "all": all axes are labelled.
+        direction = options.list[0].getfieldvalue('direction', 'row')  # {"row", "column"}, default: "row"
+        axes_pad = options.list[0].getfieldvalue('axes_pad', 0.25)  # float or (float, float), default : 0.02; Padding or (horizonal padding, vertical padding) between axes, in inches
+        add_all = options.list[0].getfieldvalue('add_all', True)  # bool, default: True
+        share_all = options.list[0].getfieldvalue('share_all', True)  # bool, default: False
+        label_mode = options.list[0].getfieldvalue('label_mode', 'L')  # {"L", "1", "all"}, default: "L"; Determines which axes will get tick labels: "L": All axes on the left column get vertical tick labels; all axes on the bottom row get horizontal tick labels;. "1": Only the bottom left axes is labelled. "all": all axes are labelled.
 
         # Translate MATLAB colorbar mode to matplotlib
Index: issm/trunk/src/m/plot/processdata.py
===================================================================
--- issm/trunk/src/m/plot/processdata.py	(revision 27035)
+++ issm/trunk/src/m/plot/processdata.py	(revision 27232)
@@ -8,5 +8,7 @@
     datatype = 2 -> nodes
     datatype = 3 -> node quivers
-    datatype = 4 -> patch
+    datatype = 4 -> P1 patch
+    datatype = 5 -> P0 patch
+    datatype = 6 -> edges
 
     Usage:
@@ -24,4 +26,9 @@
     else:
         numberofvertices2d = np.nan
+
+    try:
+        numberofedges = md.mesh.numberofedges
+    except AttributeError:
+        numberofedges = np.nan
 
     if options.exist('amr'):
@@ -52,5 +59,5 @@
     # }}}
 
-    #  log {{{
+    # log {{{
     if options.exist('log'):
         cutoff = options.getfieldvalue('log', 1)
@@ -58,13 +65,27 @@
     # }}}
 
-    #  quiver plot {{{
+    # quiver plot {{{
     if datasize[1] > 1 and datasize[0] != numberofvertices + 1:
-        if datasize[0] == numberofvertices and datasize[1] == 2:
+        if datasize[0] == numberofvertices and datasize[1] in [2, 3]:
             datatype = 3
+            if md.mesh.dimension() == 3:
+                if datasize[1] == 2:
+                    data = np.hstack(data, np.zeros((datasize[0])))
+                elif datasize[1] > 3:
+                    raise ValueError('plotmodel error message: data should have two or three columns of length md.mesh.numberofvertices for a quiver plot')
         else:
-            raise ValueError('plotmodel error message: data should have two columns of length md.mesh.numberofvertices for a quiver plot')
+            #we should have a patch
+            print("Assuming that data provided is a patch")
+            datatype = 4
+            index = md.mesh.elements
+            if np.shape(data)[1] < np.shape(index)[1]:
+                    raise ValueError('plotmodel error message: data should have more columns than vertices per elements to plot a patch')
+            procdata = np.zeros((numberofvertices))
+            procdata[md.mesh.elements -1] = data[:, 0:np.shape(index)[1]]
+            datasize = [numberofvertices, 1]
+
     # }}}
 
-    #  element data{{{
+    # element data{{{
     if datasize[0] == numberofelements and datasize[1] == 1:
         #initialize datatype if non patch
@@ -93,6 +114,6 @@
     # }}}
 
-    #  node data {{{
-    if datasize[0] in [numberofvertices, numberofvertices2d] and datasize[1] == 1:
+    # node data {{{
+    elif datasize[0] in [numberofvertices, numberofvertices2d] and datasize[1] == 1:
         datatype = 2
         # AMR {{{
@@ -101,5 +122,5 @@
             procdata = procdata[nonan]
         # }}}
-        #  Mask {{{
+        # Mask {{{
         if options.exist('mask'):
             flags = options.getfieldvalue('mask')
@@ -119,6 +140,19 @@
     # }}}
 
-    #  spc time series {{{
-    if datasize[0] == numberofvertices + 1:
+    # edge data {{{
+    elif datasize[0] in [numberofedges] and datasize[1] == 1:
+        datatype = 6
+        procdata = np.zeros((md.mesh.numberofelements))
+        repeat = np.zeros((md.mesh.numberofelements))
+        for index, edge in enumerate(md.mesh.edges[:, -2:]):
+            procdata[edge - 1] += data[index] * np.asarray(edge - 1 > -1, dtype=int)
+            repeat[edge - 1] += np.asarray(edge - 1 > -1, dtype=int)
+        procdata = procdata / repeat
+
+        # }}}
+    # }}}
+
+    # spc time series {{{
+    elif datasize[0] == numberofvertices + 1:
         datatype = 2
         spccol = options.getfieldvalue('spccol', 0)
@@ -127,12 +161,7 @@
         procdata = procdata[0:-1, spccol]
 
-        #mask?
-
-        #layer projection?
-
-        #control arrow density if quiver plot
     # }}}
 
-    # convert rank - 2 array to rank - 1 {{{
+    # convert rank -2 array to rank -1 {{{
     if np.ndim(procdata) == 2 and np.shape(procdata)[1] == 1:
         procdata = procdata.reshape(-1, )
@@ -142,16 +171,23 @@
     nanfill = options.getfieldvalue('nan', -9999)
     if np.any(np.isnan(procdata)):
-        lb = np.nanmin(procdata)
-        ub = np.nanmax(procdata)
-        if lb == ub:
-            lb = lb - 0.5
-            ub = ub + 0.5
-            nanfill = lb - 1
+        if options.exist('caxis'):
+            [lb, ub] = options.getfieldvalue('caxis')
+        else:
+            lb = np.nanmin(procdata)
+            ub = np.nanmax(procdata)
+            if lb == ub:
+                lb = lb - 0.5
+                ub = ub + 0.5
+                nanfill = lb - 1
+            options.addfielddefault('caxis', [lb, ub])
+
         procdata[np.isnan(procdata)] = nanfill
         procdata = np.ma.array(procdata, mask=np.isnan(procdata))
-        #clim looks to be deprecated and replaced by caxis
-        #options.addfielddefault('clim', [lb, ub])
-        options.addfielddefault('cmap_set_under', '1')
-        print(("WARNING: nan's treated as", nanfill, "by default.  Change using pairoption 'nan', nan_fill_value in plotmodel call"))
+        if nanfill < lb:
+            options.addfielddefault('cmap_set_under', 'r')
+        elif nanfill > ub:
+            options.addfielddefault('cmap_set_over', 'k')
+        if nanfill < ub and nanfill > lb:
+            print(("WARNING: nan's treated as", nanfill, "by default. Which is in your data interval, change it with ['nan', value] in plotmodel options"))
     # }}}
 
Index: issm/trunk/src/m/solve/waitonlock.py
===================================================================
--- issm/trunk/src/m/solve/waitonlock.py	(revision 27035)
+++ issm/trunk/src/m/solve/waitonlock.py	(revision 27232)
@@ -11,6 +11,6 @@
     """WAITONLOCK - wait for a file
 
-    This routine will return when a file named 'lockfilename' is written to 
-    disk. Also check for outlog file because it might be written several 
+    This routine will return when a file named 'lockfilename' is written to
+    disk. Also check for outlog file because it might be written several
     seconds after the lock file.
 
@@ -21,5 +21,5 @@
 
     TODO:
-    - Uncomment import of localpfe and check on cluster type once localpfe.py 
+    - Uncomment import of localpfe and check on cluster type once localpfe.py
     has been translated from localpfe.m.
     """
@@ -79,12 +79,13 @@
             sys.stdout.write('\rchecking for job completion (time: {} min {} sec)      '.format(floor(elapsedtime / 60), floor(rem(elapsedtime, 60)))) # TODO: After Python 2 is deprecated, we can change this call to print([...], end='')
             elapsedtime = elapsedtime / 60 # Converts time from sec to min
-            subproc = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
-            outs, errs = subproc.communicate() # NOTE: Need to consume output before checking return code
+            subproc = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, universal_newlines=True)
+            outs, errs = subproc.communicate()  # NOTE: Need to consume output before checking return code
 
             # TODO: Debug the following check under Linux (exits after first iteration with errs = "b")
             # UPDATE: Works in testing under Debian Linux system. Leaving comment for now so that it is easier to backtrace this issue if someone else encounters it.
+            # FIXED: comunicates returns stuff in bytes in Python 3 unless you set "universal_newlines=True"
             #
-            #if errs != '':
-            #    raise Exception('waitonlock: check for existence of files failed: {}'.format(errs))
+            if errs != '':
+               raise Exception('waitonlock: check for existence of files failed: {}'.format(errs))
             ispresent = not subproc.returncode
             if ispresent:
Index: issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp
===================================================================
--- issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp	(revision 27035)
+++ issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp	(revision 27232)
@@ -98,4 +98,16 @@
 		#endif
 	}
+	else if(strcmp(name,"_PETSC_HAVE_CUDA_")==0){
+		value = 0.;
+		#ifdef PETSC_HAVE_CUDA
+		value = 1.;
+		#endif
+	}
+	else if(strcmp(name,"_PETSC_HAVE_PASTIX_")==0){
+		value = 0.;
+		#ifdef PETSC_HAVE_PASTIX
+		value = 1.;
+		#endif
+	}
 	else if(strcmp(name,"_DAKOTA_VERSION_")==0){
 		#ifdef _DAKOTA_VERSION_
Index: issm/trunk/src/wrappers/matlab/Makefile.am
===================================================================
--- issm/trunk/src/wrappers/matlab/Makefile.am	(revision 27035)
+++ issm/trunk/src/wrappers/matlab/Makefile.am	(revision 27232)
@@ -122,5 +122,5 @@
 AM_LDFLAGS += -Wl,-rpath,'@rpath'
 else
-AM_LDFLAGS += -Wl,-static -Wl,--disable-new-dtags -Wl,-rpath,'$$ORIGIN'
+AM_LDFLAGS += -Wl,-static -Wl,-lbacktrace -Wl,--disable-new-dtags -Wl,-rpath,'$$ORIGIN'
 endif
 endif
Index: issm/trunk/src/wrappers/python/Makefile.am
===================================================================
--- issm/trunk/src/wrappers/python/Makefile.am	(revision 27035)
+++ issm/trunk/src/wrappers/python/Makefile.am	(revision 27232)
@@ -76,5 +76,5 @@
 AM_LDFLAGS += -Wl,-rpath,'@rpath'
 else
-AM_LDFLAGS += -Wl,-static -Wl,--disable-new-dtags -Wl,-rpath,'$$ORIGIN'
+AM_LDFLAGS += -Wl,-static -Wl,-lbacktrace -Wl,--disable-new-dtags -Wl,-rpath,'$$ORIGIN'
 endif
 endif
